package componentesconlibreriasmm.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import componentesconlibreriasmm.Componente;
import componentesconlibreriasmm.Conector;
import componentesconlibreriasmm.Sistema;
import componentesconlibreriasmm.diagram.edit.policies.ComponentesConLibreriasMMBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class ConectorReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public ConectorReorientCommand(ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == getElementToEdit() instanceof Conector) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof Componente && newEnd instanceof Componente)) {
			return false;
		}
		Componente target = getLink().getDestino();
		if (!(getLink().eContainer() instanceof Sistema)) {
			return false;
		}
		Sistema container = (Sistema) getLink().eContainer();
		return ComponentesConLibreriasMMBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistConector_4001(container,
						getLink(), getNewSource(), target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof Componente && newEnd instanceof Componente)) {
			return false;
		}
		Componente source = getLink().getOrigen();
		if (!(getLink().eContainer() instanceof Sistema)) {
			return false;
		}
		Sistema container = (Sistema) getLink().eContainer();
		return ComponentesConLibreriasMMBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistConector_4001(container,
						getLink(), source, getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setOrigen(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setDestino(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected Conector getLink() {
		return (Conector) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected Componente getOldSource() {
		return (Componente) oldEnd;
	}

	/**
	 * @generated
	 */
	protected Componente getNewSource() {
		return (Componente) newEnd;
	}

	/**
	 * @generated
	 */
	protected Componente getOldTarget() {
		return (Componente) oldEnd;
	}

	/**
	 * @generated
	 */
	protected Componente getNewTarget() {
		return (Componente) newEnd;
	}
}
