package componentesconlibreriasmm.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.common.core.command.ICompositeCommand;
import org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand;
import org.eclipse.gmf.runtime.emf.commands.core.command.CompositeTransactionalCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

import componentesconlibreriasmm.diagram.edit.commands.ConectorCreateCommand;
import componentesconlibreriasmm.diagram.edit.commands.ConectorReorientCommand;
import componentesconlibreriasmm.diagram.edit.parts.ComponenteCompartimentoComponenteEditPart;
import componentesconlibreriasmm.diagram.edit.parts.ConectorEditPart;
import componentesconlibreriasmm.diagram.edit.parts.LibreriaEditPart;
import componentesconlibreriasmm.diagram.part.ComponentesConLibreriasMMVisualIDRegistry;
import componentesconlibreriasmm.diagram.providers.ComponentesConLibreriasMMElementTypes;

/**
 * @generated
 */
public class ComponenteItemSemanticEditPolicy extends
		ComponentesConLibreriasMMBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public ComponenteItemSemanticEditPolicy() {
		super(ComponentesConLibreriasMMElementTypes.Componente_2001);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		View view = (View) getHost().getModel();
		CompositeTransactionalCommand cmd = new CompositeTransactionalCommand(
				getEditingDomain(), null);
		cmd.setTransactionNestingEnabled(false);
		for (Iterator/*[?]*/it = view.getTargetEdges().iterator(); it
				.hasNext();) {
			Edge incomingLink = (Edge) it.next();
			if (ComponentesConLibreriasMMVisualIDRegistry
					.getVisualID(incomingLink) == ConectorEditPart.VISUAL_ID) {
				DestroyElementRequest r = new DestroyElementRequest(
						incomingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
		}
		for (Iterator/*[?]*/it = view.getSourceEdges().iterator(); it
				.hasNext();) {
			Edge outgoingLink = (Edge) it.next();
			if (ComponentesConLibreriasMMVisualIDRegistry
					.getVisualID(outgoingLink) == ConectorEditPart.VISUAL_ID) {
				DestroyElementRequest r = new DestroyElementRequest(
						outgoingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
		}
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation == null) {
			// there are indirectly referenced children, need extra commands: false
			addDestroyChildNodesCommand(cmd);
			addDestroyShortcutsCommand(cmd, view);
			// delete host element
			cmd.add(new DestroyElementCommand(req));
		} else {
			cmd.add(new DeleteCommand(getEditingDomain(), view));
		}
		return getGEFWrapper(cmd.reduce());
	}

	/**
	 * @generated
	 */
	private void addDestroyChildNodesCommand(ICompositeCommand cmd) {
		View view = (View) getHost().getModel();
		for (Iterator/*[?]*/nit = view.getChildren().iterator(); nit.hasNext();) {
			Node node = (Node) nit.next();
			switch (ComponentesConLibreriasMMVisualIDRegistry.getVisualID(node)) {
			case ComponenteCompartimentoComponenteEditPart.VISUAL_ID:
				for (Iterator/*[?]*/cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (ComponentesConLibreriasMMVisualIDRegistry
							.getVisualID(cnode)) {
					case LibreriaEditPart.VISUAL_ID:
						cmd.add(new DestroyElementCommand(
								new DestroyElementRequest(getEditingDomain(),
										cnode.getElement(), false))); // directlyOwned: true
						// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
						// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
						break;
					}
				}
				break;
			}
		}
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (ComponentesConLibreriasMMElementTypes.Conector_4001 == req
				.getElementType()) {
			return getGEFWrapper(new ConectorCreateCommand(req,
					req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (ComponentesConLibreriasMMElementTypes.Conector_4001 == req
				.getElementType()) {
			return getGEFWrapper(new ConectorCreateCommand(req,
					req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EClass based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientRelationshipCommand(
			ReorientRelationshipRequest req) {
		switch (getVisualID(req)) {
		case ConectorEditPart.VISUAL_ID:
			return getGEFWrapper(new ConectorReorientCommand(req));
		}
		return super.getReorientRelationshipCommand(req);
	}

}
