
#include "platformServicesConfig.h"
#include "platformServices.h"

//*****************************************************************************
//
// The clock rate for the SysTick interrupt.  All events in the application
// occur at some fraction of this clock rate.
//
//*****************************************************************************
#define CLOCK_RATE              8000

void PLATFORM_SERVICES_init(){

	//Esto habra que hacerlo por configuracion de uso de codigo por #ifdef
	//y de linkado por directorios
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOG);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_PWM);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_UART0);

	PROCESSOR_init();
	DISPLAY_init();
	LEDS_init();

	//UART_DRIVER_SIMPLE_open();
	UART_DRIVER_SIMPLE_open();
	KEYPAD_init();
	/*UART_LOGGING_init();
	AUDIO_init();
	 */

   #ifdef SYSTICK
		SysTickPeriodSet(SysCtlClockGet() / 100);
		SysTickIntEnable();
		SysTickEnable();
	#endif

	#ifdef SIMPLE_SCHEDULER
		SCHEDULER_init();
	#endif


   IntMasterEnable();

}

void PLATFORM_SERVICES_delay(unsigned long ulCount){
	unsigned long i = 0;

	for(i=0; i< ulCount ; i++);

}
