
#include "drivers/displayOLED/rit128x96x4.h"
#include <stdio.h>
#include <string.h>

#include "displayOLED.h"


#define CHAR_WIDTH 6
#define LINE_HEIGHT 8

char displayImage[MAX_LINES][MAX_COLUMNS+1];


void DISPLAY_OLED_init(void){
	int i,j;

	  RIT128x96x4Init(1000000);
	  for(i=0;i<MAX_LINES;i++)
	  {
	    for(j=0;j<MAX_COLUMNS;j++) displayImage[i][j]=' ';
		  displayImage[i][MAX_COLUMNS]='\0';
	  }
	  RIT128x96x4Disable();
}


void DISPLAY_OLED_close(void){

}

void DISPLAY_OLED_refresh(void){
	 int y;

	 for(y=0;y<MAX_LINES;y++)
	    RIT128x96x4StringDraw( displayImage[y], 0, y*LINE_HEIGHT, 15);

}
void DISPLAY_OLED_eraseConsoleLine(int y){
	  int j;

	  for(j=0;j<MAX_COLUMNS;j++) displayImage[y][j]=' ';

}
void DISPLAY_OLED_writeText(int x , int y , char *str){
	int n;

	 n=strlen(str);
	 if(n>(MAX_COLUMNS-x)) n=MAX_COLUMNS-x;
	 strncpy( displayImage[y]+x,str,n);
}
void DISPLAY_OLED_writeImage(int x , int y , char *imageFile){

}
void DISPLAY_OLED_refreshConsoleLine(int y){
	RIT128x96x4StringDraw(displayImage[y], 0, y*LINE_HEIGHT, 15);
}

