/*
* generated by Xtext
*/
package org.xtext.ui.contentassist;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.ui.editor.contentassist.ContentAssistContext;
import org.eclipse.xtext.ui.editor.contentassist.ICompletionProposalAcceptor;
import org.xtext.ui.contentassist.AbstractReusableComponentsProposalProvider;

import reusablecomponents.Component;
import reusablecomponents.Connector;
import reusablecomponents.Port;
import reusablecomponents.ServiceDef;

/**
 * see http://www.eclipse.org/Xtext/documentation/latest/xtext.html#contentAssist on how to customize content assistant
 */
public class ReusableComponentsProposalProvider extends AbstractReusableComponentsProposalProvider {

	@Override
	public void completeConnector_EndB(EObject obj, 
			Assignment assignment, 
			ContentAssistContext context, 
			ICompletionProposalAcceptor acceptor) {		
	
		EList<Port> ports;
		EList<ServiceDef> services;
		String auxName;
		int j;
		
		// Puerto contectado en endA del conector
		Port port_endA = ((Connector)obj).getEndA();
		
		// Lista con todos los componentes del modelo
		EList<Component> components = ((reusablecomponents.System) obj.eContainer()).getComponents(); 	
		
		/*
		 *  Recorre los puertos de los componentes definidos en el modelo para encontrar
		 *  los puertos compatibles
		 */
		for(int i=0; i<components.size(); i++) 
		{
			ports = components.get(i).getPorts();
			j=0;
			while(j<ports.size() && !components.get(i).getName().equals(((Component)port_endA.eContainer()).getName())) 
			{
				services = ports.get(j).getDefinition().getServices();
				if(services.containsAll(port_endA.getDefinition().getServices()))
				{
					auxName = ((Component)ports.get(j).eContainer()).getName() + "." + ports.get(j).getName();
					acceptor.accept(createCompletionProposal(auxName, auxName, null, context));
				}
				j++;
			}
		}
	}
	
}
