package org.xtext.ui.syntaxcoloring;

import org.eclipse.xtext.ui.editor.syntaxcoloring.DefaultHighlightingConfiguration;
import org.eclipse.xtext.ui.editor.syntaxcoloring.IHighlightingConfigurationAcceptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.xtext.ui.editor.utils.TextStyle;

/*
 * Este mtodo sobreescribe el estilo por defecto del editor
 */
public class MyHighlightingConfiguration extends DefaultHighlightingConfiguration {

	/*
	 *  Definicin del identificador de una nueva categora lxica que ser asociada
	 *  a las palabras clave de las definiciones, como "ComponentDef", "PortDef", etc.
	 */
	public static final String DEFINITION_KEYWORD_ID = "DefinitionKeyword";

	// Registro de la nueva categora
	public void configure(IHighlightingConfigurationAcceptor acceptor) {
		super.configure(acceptor);
		acceptor.acceptDefaultHighlighting(DEFINITION_KEYWORD_ID, "Main Keyword", definitionKeywordTextStyle());
	}   
	
	// Implementacin del estilo de la categora 
	public TextStyle definitionKeywordTextStyle() {
		TextStyle textStyle = new TextStyle();
		textStyle.setFontData(new FontData("Monaco", 11, SWT.BOLD));
		textStyle.setColor(new RGB(31, 87, 60));
		return textStyle;
	}
}