package org.xtext.validation;

import org.eclipse.emf.common.util.EList;
import org.eclipse.xtext.validation.Check;

import reusablecomponents.ComponentDef;
import reusablecomponents.Connector;
import reusablecomponents.ReusablecomponentsPackage;
import reusablecomponents.ServiceDef;


public class ReusableComponentsJavaValidator extends AbstractReusableComponentsJavaValidator {

	@Check
	public void validarNombre(ComponentDef componentdef) {	
		if (!componentdef.getName().endsWith("def")) {
			warning("Nombre de la definicin mal formado", 
					ReusablecomponentsPackage.Literals.COMPONENT_DEF__NAME);
		}
	}
	
	@Check
	public void validarCompatibilidad(Connector connector) {
		
		EList<ServiceDef> services_endA = connector.getEndA().getDefinition().getServices();
		EList<ServiceDef> services_endB = connector.getEndB().getDefinition().getServices();

		if (!services_endA.containsAll(services_endB) || !services_endB.containsAll(services_endA))
		{
			error("Conexin entre puertos no compatibles",
					ReusablecomponentsPackage.Literals.CONNECTOR__END_B);
		}
	}
}
