package org.xtext.naming;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.naming.QualifiedName;
import org.eclipse.xtext.naming.SimpleNameProvider;

import simplecomponents.Component;
import simplecomponents.Port;

public class SimpleComponentsIQualifiedNameProvider extends SimpleNameProvider {
	
	@Override
	public QualifiedName getFullyQualifiedName(EObject obj) {
		
		String name;
		QualifiedName result = null;
		
		if (obj instanceof Component) {
			name = ((Component) obj).getName();
		
			if(name != null && !name.isEmpty())
				result = super.getFullyQualifiedName(obj);
		}
		else if(obj instanceof Port) {
			name = ((Port) obj).getName();
			
			if(name != null && !name.isEmpty())
				result = super.getFullyQualifiedName(obj);
		}
		else {
			result = super.getFullyQualifiedName(obj);
		}
		
		return result;
	}

}
