package org.xtext.serialization;

import java.io.File;
import java.io.IOException;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.resource.XtextResourceSet;
import org.xtext.SimpleComponentsStandaloneSetup;

import simplecomponents.SimplecomponentsPackage;

import com.google.inject.Injector;

/*
 * Para ejecutar: seleccione este fichero en el Package Explorer y haga clic
 * en la opción "Run as..." -> "Java Application" del menú contextual. Para
 * abrir el archivo de salida: "modelo2.xmi", deberá registrar previamente el 
 * meta-modelo SimpleComponents.ecore, para ello, accione la perspectiva ATL 
 * (Window->Open Perspective->Other->ATL) (requiere tener instalado ATL),
 * seleccione SimpleComponents.ecore en el Package Explorer, pulse el segundo
 * botón del ratón y haga clic en "Register Metamodel"
 */
public class Xtext2Xmi {

	public static void main(String[] args) {
			
		// Ruta del fichero origen de la serialización 
		File input = new File ("../Models/Serialization/input/modelo2.scomp");
		
		// Ruta del fichero destino de la serialización
		File output = new File ("../Models/Serialization/output/modelo2.xmi");
		
		// Registro del EPackage del meta-modelo SimpleComponents
		EPackage.Registry.INSTANCE.put(SimplecomponentsPackage.eNS_URI, SimplecomponentsPackage.eINSTANCE);
			
		// Recurso Xtext con la información del modelo textual de entrada
		Injector injector = new SimpleComponentsStandaloneSetup().createInjectorAndDoEMFRegistration();
		ResourceSet xtextResourceSet = injector.getInstance(XtextResourceSet.class);
		XtextResource xtextResource = (XtextResource)xtextResourceSet.getResource( 
				URI.createURI("file:" + input.getAbsolutePath()), true);
		EcoreUtil.resolveAll(xtextResource);	
		
		// Creación de un recurso XMI de salida vacío
		Resource xmiResource = new ResourceSetImpl().createResource(
		URI.createURI("file:" + output.getAbsolutePath()));

		// Grabación del recurso XMI con la información del modelo Xtext
		xmiResource.getContents().add(xtextResource.getContents().get(0));

		try {
			xmiResource.save(null);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
